/* AMX Mod script.
*
* (c) Copyright 2002, OLO
* This file is provided as is (no warranties).
*
*/

#include <amxmod>
#include <amxmisc>

public admin_kick(id,level,cid){
	if (!cmd_access(id,level,cid,2))
		return PLUGIN_HANDLED
	new arg[32]
	read_argv(1,arg,31)
	new player = find_player("c",arg)
	if (!player) player = find_player("bl",arg)
	if (!player){
		console_print(id,"[AMX] Client with that authid or part of nick not found.")
		return PLUGIN_HANDLED
	}
	if (get_user_flags(player)&ADMIN_IMMUNITY){
		new imname[32]
		get_user_name(player,imname,31)
		console_print(id,"[AMX] Client ^"%s^" has immunity.",imname)
		return PLUGIN_HANDLED
	}
	new authid[16],authid2[16],name2[32],name[32],userid2, arg2[32]
	get_user_authid(id,authid,15)
	get_user_authid(player,authid2,15)
	get_user_name(player,name2,31)
	get_user_name(id,name,31)
	userid2 = get_user_userid(player)
	read_argv(2,arg2,31)
	log_to_file("addons/amx/admin.log","^"%s<%d><%s><>^" kick ^"%s<%d><%s><>^" (reason ^"%s^")", 
		name,get_user_userid(id),authid, name2,userid2,authid2,arg2 )
	server_cmd("kick #%d",userid2)
	console_print(id,"[AMX] Client ^"%s^" kicked.",name2)
	return PLUGIN_HANDLED_MAIN
}

public admin_ban(id,level,cid){
	if (!cmd_access(id,level,cid,3))
		return PLUGIN_HANDLED
	new arg[32]
	read_argv(2,arg,31)
	new player = find_player("c",arg)
	if (!player) player = find_player("bl",arg)
	if (!player){
		console_print(id,"[AMX] Client with that authid or part of nick not found.")
		return PLUGIN_HANDLED
	}
	if (get_user_flags(player)&ADMIN_IMMUNITY){
		new imname[32]
		get_user_name(player,imname,31)
		console_print(id,"[AMX] Client ^"%s^" has immunity.",imname)
		return PLUGIN_HANDLED
	}
	if (is_user_bot(player)){
		new imname[32]
		get_user_name(player,imname,31)	
		console_print(id,"[AMX] That action can't be performed on bot ^"%s^".",imname)
		return PLUGIN_HANDLED
	}
	new minutes[32],authid[16],name2[32],authid2[16],name[32], arg3[32]
	read_argv(1,minutes,31)
	get_user_authid(player,authid2,15)
	get_user_authid(id,authid,15)
	get_user_name(player,name2,31)
	get_user_name(id,name,31)
	read_argv(3,arg3,31)
	log_to_file("addons/amx/admin.log","^"%s<%d><%s><>^" ban and kick ^"%s<%d><%s><>^" (minutes ^"%s^") (reason ^"%s^")", 
		name,get_user_userid(id),authid, name2,get_user_userid(player),authid2,minutes,arg3 )
	server_cmd("banid %s %s kick;writeid",minutes,authid2)
	console_print(id,"[AMX] Client ^"%s^" banned.",name2)
	return PLUGIN_HANDLED_MAIN
}

public admin_slay(id,level,cid){
	if (!cmd_access(id,level,cid,2))
		return PLUGIN_HANDLED
	new arg[32]
	read_argv(1,arg,31)
	new player = find_player("c",arg)
	if (!player) player = find_player("bl",arg)
	if (!player){
		console_print(id,"[AMX] Client with that authid or part of nick not found.")
		return PLUGIN_HANDLED
	}
	if (get_user_flags(player)&ADMIN_IMMUNITY){
		new imname[32]
		get_user_name(player,imname,31)
		console_print(id,"[AMX] Client ^"%s^" has immunity.",imname)
		return PLUGIN_HANDLED
	}
	if (!is_user_alive(player)){
		new imname[32]
		get_user_name(player,imname,31)	
		console_print(id,"[AMX] That action can't be performed on dead client ^"%s^".",imname)
		return PLUGIN_HANDLED
	}
	user_kill(player)
	new authid[16],name2[32],authid2[16],name[32]
	get_user_authid(id,authid,15)
	get_user_name(id,name,31)
	get_user_authid(player,authid2,15)
	get_user_name(player,name2,31)
	log_to_file("addons/amx/admin.log","^"%s<%d><%s><>^" slay ^"%s<%d><%s><>^"",
		name,get_user_userid(id),authid, name2,get_user_userid(player),authid2 )
	console_print(id,"[AMX] Client ^"%s^" slayed.",name2)
	return PLUGIN_HANDLED_MAIN
}

public admin_slap(id,level,cid){
	if (!cmd_access(id,level,cid,2))
		return PLUGIN_HANDLED
	new arg[32]
	read_argv(1,arg,31)
	new player = find_player("c",arg)
	if (!player) player = find_player("bl",arg)
	if (!player){
		console_print(id,"[AMX] Client with that authid or part of nick not found.")
		return PLUGIN_HANDLED
	}
	if (get_user_flags(player)&ADMIN_IMMUNITY){
		new imname[32]
		get_user_name(player,imname,31)
		console_print(id,"[AMX] Client ^"%s^" has immunity.",imname)
		return PLUGIN_HANDLED
	}
	if (!is_user_alive(player)){
		new imname[32]
		get_user_name(player,imname,31)	
		console_print(id,"[AMX] That action can't be performed on dead client ^"%s^".",imname)
		return PLUGIN_HANDLED
	}
	new power[32],authid[16],name2[32],authid2[16],name[32]
	read_argv(2,power,31)
	new damage = strtonum(power)
	user_slap(player,damage)
	get_user_authid(id,authid,15)
	get_user_name(id,name,31)
	get_user_authid(player,authid2,15)
	get_user_name(player,name2,31)
	log_to_file("addons/amx/admin.log","^"%s<%d><%s><>^" slap with %d damage ^"%s<%d><%s><>^"",
		name,get_user_userid(id),authid, damage,name2,get_user_userid(player),authid2 )
	console_print(id,"[AMX] Client ^"%s^" slaped with %d damage.",name2,damage)	
	return PLUGIN_HANDLED_MAIN
}

public delayed_map(mapname[])
	server_cmd("changelevel %s",mapname)

public admin_map(id,level,cid){
	if (!cmd_access(id,level,cid,2))
		return PLUGIN_HANDLED
	new arg[32]
	new len = read_argv(1,arg,31)
	if (is_map_valid(arg)==0){
		console_print(id,"[AMX] Map with that name not found or map is invalid.")
		return PLUGIN_HANDLED
	}
	console_print(id,"[AMX] Changing map.")
	if (read_argc() > 2){
		message_begin(MSG_ALL, SVC_INTERMISSION)
		message_end()
		new arg2[32]
		read_argv(2,arg2,31)
		new Float:ftime = floatstr(arg2)
		if (ftime < 0.0) ftime = 0.0
		set_task( ftime + 0.5 ,"delayed_map",0,arg,len + 1)
	}
	else {
		set_task(0.5,"delayed_map",0,arg,len + 1)
	}
	new authid[16],name[32]
	get_user_authid(id,authid,15)
	get_user_name(id,name,31)
	log_to_file("addons/amx/admin.log","^"%s<%d><%s><>^" changelevel ^"%s^"",
		name,get_user_userid(id),authid, arg)
	return PLUGIN_HANDLED_MAIN
}

public admin_cvar(id,level,cid){
	if (!cmd_access(id,level,cid,3))
		return PLUGIN_HANDLED
	new arg[32], arg2[64]
	read_argv(1,arg,31)
	read_argv(2,arg2,63)
	if (!cvar_exists(arg)){
		console_print(id,"[AMX] Unknown cvar.")
		return PLUGIN_HANDLED	
	}
	if (equal(arg,"rcon_password") && !(get_user_flags(id) & ADMIN_RCON)){
		console_print(id,"[AMX] You have no access to that cvar.")
		return PLUGIN_HANDLED
	}
	else if (equal(arg,"sv_password") && !(get_user_flags(id) & ADMIN_PASSWORD)){
		console_print(id,"[AMX] You have no access to that cvar.")
		return PLUGIN_HANDLED
	}
	new authid[16],name[32]
	get_user_authid(id,authid,15)
	get_user_name(id,name,31)
	log_to_file("addons/amx/admin.log","^"%s<%d><%s><>^" set cvar (name ^"%s^") (value ^"%s^")",
		name,get_user_userid(id),authid, arg,arg2)
	set_cvar_string(arg,arg2);
	console_print(id,"[AMX] Cvar ^"%s^" changed to ^"%s^".",arg,arg2)
	return PLUGIN_HANDLED_MAIN
}

public admin_cfg(id,level,cid){
	if (!cmd_access(id,level,cid,2))
		return PLUGIN_HANDLED
	new arg[128]
	read_argv(1,arg,127)
	if (!file_exists(arg)){
		console_print(id,"[AMX] File ^"%s^" not found.",arg)
		return PLUGIN_HANDLED	
	}
	new authid[16],name[32]
	get_user_authid(id,authid,15)
	get_user_name(id,name,31)
	log_to_file("addons/amx/admin.log","^"%s<%d><%s><>^" execute cfg (file ^"%s^")",
		name,get_user_userid(id),authid, arg)
	console_print(id,"[AMX] Executing file ^"%s^".",arg)
	server_cmd("exec %s",arg)
	return PLUGIN_HANDLED_MAIN
}

public admin_rcon(id,level,cid){
	if (!cmd_access(id,level,cid,2))
		return PLUGIN_HANDLED
	new arg[128],authid[16],name[32]
	read_args(arg,127)
	get_user_authid(id,authid,15)
	get_user_name(id,name,31)
	log_to_file("addons/amx/admin.log","^"%s<%d><%s><>^" server console (cmdline ^"%s^")",
		name,get_user_userid(id),authid, arg)
	console_print(id,"[AMX] Commmand line ^"%s^" sent to server console.",arg)
	server_cmd(arg)
	return PLUGIN_HANDLED_MAIN
}

public admin_who(id,level,cid){
	new players[32], inum, authid[16],name[32], flags
	get_players(players,inum)
	console_print(id,"^n[AMX] Clients on server:^n #  %-32.31s %-16.15s %-4.3s %-4.3s %s",
		"nick","authid","imm","res","access")
	for(new a = 0; a < inum; ++a)	{
			get_user_authid(players[a],authid,15)
			get_user_name(players[a],name,31)
			flags = get_user_flags(players[a])
			console_print(id,"%2d  %-32.31s %-16.15s %-4.3s %-4.3s %d",
				players[a],name,authid,(flags&ADMIN_IMMUNITY)?"yes":"no",(flags&ADMIN_RESERVATION)?"yes":"no",flags)
	}
	console_print(id,"Total %d",inum)
	get_user_authid(id,authid,15)
	get_user_name(id,name,31)
	log_to_file("addons/amx/admin.log","^"%s<%d><%s><>^" ask for players list.",name,get_user_userid(id),authid)	
	return PLUGIN_HANDLED_MAIN
}

public plugin_init(){
	register_plugin("Admin Commands","0.8","default")
	register_concmd("amx_kick","admin_kick",ADMIN_KICK,"< authid | part of nick > [ reason ]")
	register_concmd("amx_ban","admin_ban",ADMIN_BAN,"< minutes > < authid | part of nick > [ reason ]")
	register_concmd("amx_slay","admin_slay",ADMIN_SLAY,"< authid | part of nick >")
	register_concmd("amx_slap","admin_slap",ADMIN_SLAY,"< authid | part of nick > [ power ]")	
	register_clcmd("amx_map","admin_map",ADMIN_MAP,"< mapname > [ delay in sec. ]")
	register_clcmd("amx_cvar","admin_cvar",ADMIN_CVAR,"< cvar > < value >")
	register_clcmd("amx_cfg","admin_cfg",ADMIN_CFG,"< fliename >")
	register_clcmd("amx_rcon","admin_rcon",ADMIN_RCON,"< commad line >")
	register_concmd("amx_who","admin_who",0)
	return PLUGIN_CONTINUE
}
